This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 1132971 - Review Request: python-pyvmomi - pyVmomi is the Python SDK for the VMware vSphere API that allows you to manage ESX, ESXi, and vCenter
Review Request: python-pyvmomi - pyVmomi is the Python SDK for the VMware vSp...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Matthew Booth
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-08-22 09:02 EDT by Michael Rice
Modified: 2014-10-13 17:41 EDT (History)
4 users (show)

See Also:
Fixed In Version: python-pyvmomi-5.5.0.2014.1.1-3.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-09-29 00:07:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
mbooth: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michael Rice 2014-08-22 09:02:44 EDT
Spec URL: https://raw.githubusercontent.com/michaelrice/python-pyvmomi-rpm/master/pyvmomi.spec
SRPM URL: https://github.com/michaelrice/python-pyvmomi-rpm/raw/master/python-pyvmomi-5.5.0.2014.1-1.fc20.src.rpm
Description: pyVmomi is the Python SDK for the VMware vSphere API that allows you to manage ESX, ESXi, and vCenter.
Fedora Account System Username: errr
Comment 1 Michael Rice 2014-08-22 09:06:23 EDT
I added the FE-NEEDSPONSOR because its been a few years since I was an active package maintainer, and it looked like I was no longer sponsored.
Comment 2 Matthew Booth 2014-08-22 13:39:09 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Spec file name must match the spec package %{name}, in the format
  %{name}.spec.
  Note: pyvmomi.spec should be python-pyvmomi.spec
  See: http://fedoraproject.org/wiki/Packaging/NamingGuidelines#Spec_file_name


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[-]: License file installed when any subpackage combination is installed.
[-]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.3/site-packages/pyVmomi,
     /usr/lib/python3.3/site-packages/pyVim
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.3/site-
     packages/pyVmomi, /usr/lib/python3.3/site-packages/pyVim

Missing:
%dir %{python3_sitelib}/pyVmomi
%dir %{python3_sitelib}/pyVim

[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.

Need to use rpm-style version (see rpmlint output)

[x]: Sources contain only permissible code or content.
[-]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[!]: Package is named according to the Package Naming Guidelines.

Package should be called python-pyvmomi

[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Binary eggs must be removed in %prep
     Note: Cannot find any build in BUILD directory (--prebuilt option?)
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

I queried him myself :) I see it's added to
https://github.com/vmware/pyvmomi/issues/123

[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-pyvmomi
[x]: Package functions as described.

I tested by running the getallvms sample program for both python2 and python3.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

There are automated tests which we aren't running. This isn't a blocker, but we
should really run them if at all possible.

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Bad spec filename: /home/mbooth/tmp/1132971-pyvmomi/srpm-
     unpacked/pyvmomi.spec
     See: (this test has no URL)

Package should be called python-pyvmomi

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python-pyvmomi-5.5.0.2014.1-1.fc20.noarch.rpm
          python3-pyvmomi-5.5.0.2014.1-1.fc20.noarch.rpm
          python-pyvmomi-5.5.0.2014.1-1.fc20.src.rpm
python-pyvmomi.noarch: W: spelling-error Summary(en_US) VMware -> Firmware
python-pyvmomi.noarch: W: spelling-error Summary(en_US) vSphere -> v Sphere, sphere
python-pyvmomi.noarch: W: spelling-error %description -l en_US vSphere -> v Sphere, sphere
python-pyvmomi.noarch: W: spelling-error %description -l en_US vCenter -> v Center, center, cementer
python-pyvmomi.noarch: W: incoherent-version-in-changelog 5.5.0-2014.1-1 ['5.5.0.2014.1-1.fc20', '5.5.0.2014.1-1']
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/ManagedMethodExecutorHelper.py 0644L /usr/bin/env
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/Iso8601.py 0644L /usr/bin/env
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/DynamicTypeManagerHelper.py 0644L /usr/bin/env

I can't tell whether these are supposed to be independently executed scripts,
or not, but I suspect not. If they are, can you please fix the permissions. If
not, this is weird enough to merit a comment in the spec file.

python3-pyvmomi.noarch: W: spelling-error Summary(en_US) VMware -> Firmware
python3-pyvmomi.noarch: W: spelling-error Summary(en_US) vSphere -> v Sphere, sphere
python3-pyvmomi.noarch: W: spelling-error %description -l en_US vSphere -> v Sphere, sphere
python3-pyvmomi.noarch: W: spelling-error %description -l en_US vCenter -> v Center, center, cementer
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/Iso8601.py 0644L /usr/bin/env
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/ManagedMethodExecutorHelper.py 0644L /usr/bin/env
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/DynamicTypeManagerHelper.py 0644L /usr/bin/env

See above.

python-pyvmomi.src: W: spelling-error Summary(en_US) VMware -> Firmware
python-pyvmomi.src: W: spelling-error Summary(en_US) vSphere -> v Sphere, sphere
python-pyvmomi.src: W: spelling-error %description -l en_US vSphere -> v Sphere, sphere
python-pyvmomi.src: W: spelling-error %description -l en_US vCenter -> v Center, center, cementer
python-pyvmomi.src: E: invalid-spec-name

Already mentioned. See above.

3 packages and 0 specfiles checked; 7 errors, 13 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python3-pyvmomi python-pyvmomi
python3-pyvmomi.noarch: W: spelling-error Summary(en_US) VMware -> Firmware
python3-pyvmomi.noarch: W: spelling-error Summary(en_US) vSphere -> v Sphere, sphere
python3-pyvmomi.noarch: W: spelling-error %description -l en_US vSphere -> v Sphere, sphere
python3-pyvmomi.noarch: W: spelling-error %description -l en_US vCenter -> v Center, center, cementer
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/Iso8601.py 0644L /usr/bin/env
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/ManagedMethodExecutorHelper.py 0644L /usr/bin/env
python3-pyvmomi.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/pyVmomi/DynamicTypeManagerHelper.py 0644L /usr/bin/env

See above.

python-pyvmomi.noarch: W: spelling-error Summary(en_US) VMware -> Firmware
python-pyvmomi.noarch: W: spelling-error Summary(en_US) vSphere -> v Sphere, sphere
python-pyvmomi.noarch: W: spelling-error %description -l en_US vSphere -> v Sphere, sphere
python-pyvmomi.noarch: W: spelling-error %description -l en_US vCenter -> v Center, center, cementer
python-pyvmomi.noarch: W: incoherent-version-in-changelog 5.5.0-2014.1-1 ['5.5.0.2014.1-1.fc20', '5.5.0.2014.1-1']
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/ManagedMethodExecutorHelper.py 0644L /usr/bin/env
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/Iso8601.py 0644L /usr/bin/env
python-pyvmomi.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyVmomi/DynamicTypeManagerHelper.py 0644L /usr/bin/env

See above.

2 packages and 0 specfiles checked; 6 errors, 9 warnings.
# echo 'rpmlint-done:'



Requires
--------
python3-pyvmomi (rpmlib, GLIBC filtered):
    python(abi)
    python3-requests
    python3-six

python-pyvmomi (rpmlib, GLIBC filtered):
    python(abi)
    python-requests
    python-six



Provides
--------
python3-pyvmomi:
    python3-pyvmomi

python-pyvmomi:
    python-pyvmomi



Source checksums
----------------
https://pypi.python.org/packages/source/p/pyvmomi/pyvmomi-5.5.0-2014.1.tar.gz :
  CHECKSUM(SHA256) this package     : 21bcc7a32e26fbcef57b2d5a19d53d5b88fd4ae3a77d66d8a7eb3451cbab73f9
  CHECKSUM(SHA256) upstream package : 21bcc7a32e26fbcef57b2d5a19d53d5b88fd4ae3a77d66d8a7eb3451cbab73f9


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1132971
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Additional comments:

sitearch isn't required because there are no arch-specific components. You
should omit that.

sitelib is also superfluous for current distros, but you could leave it in for
building on RHEL 6 if you want.

As the version number is a bit tricky, I'd recommend defining it up at the top.
I played with it a bit and added:

%global pyvmomi_version 5.5.0-2014.1
%global pyvmomi_rpmversion %(echo %{pyvmomi_version} | tr "-" ".")

Which has the advantage of only needing to specify it once. You use
pyvmomi_rpmversion in Version:, and pyvmomi_version in Source0 and %prep.
However, this is a matter of preference. Feel free to ignore it.

Could you please justify all spec file values. e.g.

BuildRequires:  python2-devel python-setuptools
Requires:   python-requests python-six
BuildArch:      noarch
Comment 3 Matthew Booth 2014-08-22 13:43:10 EDT
There are a couple of blockers in there, but very easy to fix. Great work, thanks!

The automated tests would be extremely nice to have. However, if you really can't make it work it's not a blocker. If not, could you please add a comment to the spec file explaining why it doesn't work.
Comment 4 Shawn Hartsock 2014-08-26 11:18:27 EDT
Running tests is blocked on packaging for python-vcrpy and it's dependencies. The vcrpy upstream is here https://github.com/kevin1024/vcrpy and it has dependencies on PyYAML, contextdecorator, and the 'six' library.
Comment 5 Matthew Booth 2014-08-26 11:28:01 EDT
Ok, sounds like we aren't going to get the tests just yet. As I said, if you can add a comment explaining why we can't enable them that would be great. I'd only bother mentioning the immediate dep in the spec file: vcrpy.
Comment 6 Michael Rice 2014-08-31 20:28:56 EDT
Sorry about the delay in responses. I went on vacation. I am back now and have most of these changes addressed. I am currently working with upstream on some issues that cropped up in a bug fix release while I was out. Once they have those fixed up I will publish a new spec and SRPM file.

Thanks for the feedback thus far.
Comment 7 Michael Rice 2014-09-03 15:58:22 EDT
After speaking with upstream they have accepted the patch but are holding off on another bug release for a bit, so I have included the patch in the SRPM for now. Please see the updated SPEC and SRPM

SPEC:  https://github.com/michaelrice/python-pyvmomi-rpm/blob/master/python-pyvmomi.spec

SRPM: https://github.com/michaelrice/python-pyvmomi-rpm/raw/master/python-pyvmomi-5.5.0.2014.1-1.fc20.src.rpm
Comment 8 Michael Rice 2014-09-03 16:03:58 EDT
oops, somehow I messed up the SRPM.

Here is the correct link to the SRPM

SRPM: https://github.com/michaelrice/python-pyvmomi-rpm/raw/master/python-pyvmomi-5.5.0.2014.1.1-1.fc20.src.rpm
Comment 9 Michael Rice 2014-09-03 23:55:12 EDT
I noticed that fedora-review wasnt happy about the link I provided for the spec file, so I figured Id better update it with a link to the raw file

SPEC: https://raw.githubusercontent.com/michaelrice/python-pyvmomi-rpm/master/python-pyvmomi.spec

SRPM: https://github.com/michaelrice/python-pyvmomi-rpm/raw/master/python-pyvmomi-5.5.0.2014.1.1-1.fc20.src.rpm
Comment 10 Matthew Booth 2014-09-11 11:35:54 EDT
Very nice. I've re-reviewed and there are no longer any blockers. My sponsor status seems to be in limbo right now, which I'm chasing, but as soon as that's cleared up I'll approve this.

I still have a couple of non-blocking recommendations:

This doesn't need to be in there, as the package is noarch:

%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

You could simplify %files somewhat with:

%{python_sitelib}/*

in place of:

%{python_sitelib}/*.egg-info
%dir %{python_sitelib}/pyVmomi
%dir %{python_sitelib}/pyVim
%{python_sitelib}/pyVmomi/*
%{python_sitelib}/pyVim/*

(and the same for python3). These are equivalent in this package.

I haven't seen this incantation before:

%{!?_licensedir:%global license %%doc}

but it looks kosher. It's clearly defined, as the license is installed to /usr/share/licenses, and for the same reason I assume that the warning about that directory not being packaged is bogus. However, you don't need to define it twice, which you are currently doing. You could move the declaration up to the top and remove it from both %files sections.
Comment 11 Matthew Booth 2014-09-12 05:38:01 EDT
Pretty sure you already know this, but just in case you need to pick up the new package process here:

http://fedoraproject.org/wiki/Package_SCM_admin_requests#New_Packages
Comment 12 Michael Rice 2014-09-13 11:41:16 EDT
New Package SCM Request
=======================
Package Name: python-pyvmomi
Short Description: Python SDK for the VMware vSphere API
Upstream URL: https://github.com/vmware/pyvmomi
Owners: errr
Branches: f19 f20 el6 epel7
Comment 13 Jon Ciesla 2014-09-15 08:16:35 EDT
Git done (by process-git-requests).
Comment 14 Michael Rice 2014-09-23 00:28:43 EDT
Package Change Request
======================
Package Name: python-pyvmomi 
New Branches: f21
Owners: errr

Sorry when I requested the above it was as f21 went from rawhide to stable and didnt realize f21 needed to be requested.
Comment 15 Jon Ciesla 2014-09-23 08:18:00 EDT
Git done (by process-git-requests).
Comment 16 Fedora Update System 2014-09-23 22:08:02 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-pyvmomi-5.5.0.2014.1.1-2.fc19
Comment 17 Fedora Update System 2014-09-23 22:08:08 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/python-pyvmomi-5.5.0.2014.1.1-2.fc20
Comment 18 Fedora Update System 2014-09-23 22:08:14 EDT
python-pyvmomi-5.5.0.2014.1.1-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-pyvmomi-5.5.0.2014.1.1-3.el6
Comment 19 Fedora Update System 2014-09-23 22:08:21 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/python-pyvmomi-5.5.0.2014.1.1-2.fc21
Comment 20 Fedora Update System 2014-09-23 22:08:27 EDT
python-pyvmomi-5.5.0.2014.1.1-3.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/python-pyvmomi-5.5.0.2014.1.1-3.el7
Comment 21 Fedora Update System 2014-09-24 14:26:10 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc21 has been pushed to the Fedora 21 testing repository.
Comment 22 Fedora Update System 2014-09-29 00:07:41 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc21 has been pushed to the Fedora 21 stable repository.
Comment 23 Fedora Update System 2014-10-05 04:14:26 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc20 has been pushed to the Fedora 20 stable repository.
Comment 24 Fedora Update System 2014-10-05 04:15:44 EDT
python-pyvmomi-5.5.0.2014.1.1-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 25 Fedora Update System 2014-10-13 17:38:59 EDT
python-pyvmomi-5.5.0.2014.1.1-3.el7 has been pushed to the Fedora EPEL 7 stable repository.
Comment 26 Fedora Update System 2014-10-13 17:41:43 EDT
python-pyvmomi-5.5.0.2014.1.1-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.